<h1 id="title" class="title">Register</h1>

<nb-alert *ngIf="showMessages.error && errors?.length && !submitted" outline="danger" role="alert">
    <p class="alert-title"><b>Oh snap!</b></p>
    <ul class="alert-message-list">
        <li *ngFor="let error of errors" class="alert-message">{{ error }}</li>
    </ul>
</nb-alert>

<nb-alert *ngIf="showMessages.success && messages?.length && !submitted" outline="success" role="alert">
    <p class="alert-title"><b>Hooray!</b></p>
    <ul class="alert-message-list">
        <li *ngFor="let message of messages" class="alert-message">{{ message }}</li>
    </ul>
</nb-alert>

<form (ngSubmit)="register()" #form="ngForm" aria-labelledby="title">
    <div class="form-control-group">
        <label class="label" for="input-email">Email address:</label>
        <input nbInput
               [(ngModel)]="user.email"
               #email="ngModel"
               id="input-email"
               name="email"
               pattern=".+@.+..+"
               placeholder="Email address"
               fullWidth
               fieldSize="large"
               [status]="email.dirty ? (email.invalid  ? 'danger' : 'success') : 'basic'"
               [required]="getConfigValue('forms.validation.email.required')"
               [attr.aria-invalid]="email.invalid && email.touched ? true : null">
        <ng-container *ngIf="email.invalid && email.touched">
            <p class="caption status-danger" *ngIf="email.errors?.required">
                Email is required!
            </p>
            <p class="caption status-danger" *ngIf="email.errors?.pattern">
                Email should be the real one!
            </p>
        </ng-container>
    </div>

    <div class="form-control-group">
        <label class="label" for="input-password">Password:</label>
        <input nbInput
               [(ngModel)]="user.password"
               #password="ngModel"
               type="password"
               id="input-password"
               name="password"
               placeholder="Password"
               fullWidth
               fieldSize="large"
               [status]="password.dirty ? (password.invalid  ? 'danger' : 'success') : 'basic'"
               [required]="getConfigValue('forms.validation.password.required')"
               [minlength]="getConfigValue('forms.validation.password.minLength')"
               [maxlength]="getConfigValue('forms.validation.password.maxLength')"
               [attr.aria-invalid]="password.invalid && password.touched ? true : null">
        <ng-container *ngIf="password.invalid && password.touched">
            <p class="caption status-danger" *ngIf="password.errors?.required">
                Password is required!
            </p>
            <p class="caption status-danger" *ngIf="password.errors?.minlength || password.errors?.maxlength">
                Password should contain
                from {{ getConfigValue('forms.validation.password.minLength') }}
                to {{ getConfigValue('forms.validation.password.maxLength') }}
                characters
            </p>
        </ng-container>
    </div>

    <div class="form-control-group">
        <label class="label" for="input-re-password">Repeat password:</label>
        <input nbInput
               [(ngModel)]="user.confirmPassword"
               #rePass="ngModel"
               type="password"
               id="input-re-password"
               name="rePass"
               placeholder="Confirm Password"
               fullWidth
               fieldSize="large"
               [status]="rePass.dirty ? (rePass.invalid || password.value != rePass.value  ? 'danger' : 'success') : 'basic'"
               [required]="getConfigValue('forms.validation.password.required')"
               [attr.aria-invalid]="rePass.invalid && rePass.touched ? true : null">
        <ng-container *ngIf="rePass.invalid && rePass.touched">
            <p class="caption status-danger" *ngIf="rePass.errors?.required">
                Password confirmation is required!
            </p>
            <p class="caption status-danger" *ngIf="password.value != rePass.value && !rePass.errors?.required">
                Password does not match the confirm password.
            </p>
        </ng-container>
    </div>

    <button nbButton
            fullWidth
            status="primary"
            size="large"
            [disabled]="submitted || !form.valid"
            [class.btn-pulse]="submitted">
        Register
    </button>
</form>

<section class="another-action" aria-label="Sign in">
    Already have an account? <a class="text-link" routerLink="../login">Log in</a>
</section>
